\def\filedate{2018/06/26}
\def\fileversion{1.0-dev}

\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{beamerouterthemeustutt}[\filedate\space Version \fileversion\space by Philipp Tempel <philipp.tempel@isw.uni-stuttgart.de>]


\RequirePackage{etoolbox}
\RequirePackage{calc}
\RequirePackage{pgfopts}
\pgfkeys{
  /ustutt/outer/numbering/.cd,
    .is choice,
    none/.code=\setbeamertemplate{frame numbering}[none],
    counter/.code=\setbeamertemplate{frame numbering}[counter],
    fraction/.code=\setbeamertemplate{frame numbering}[fraction],
}
\pgfkeys{
  /ustutt/outer/progressbar/.cd,
    .is choice,
    none/.code={%
      \setbeamertemplate{headline}[ustutt]%
      \setbeamertemplate{frametitle}[ustutt]%
      \setbeamertemplate{footline}[ustutt]%
    },
    head/.code={\pgfkeys{/ustutt/outer/progressbar=none}%
      \setbeamertemplate{headline}[ustutt]%
      \setbeamertemplate{frametitle}[ustutt]%
      \setbeamertemplate{footline}[ustutt]%
      \setlength{\ustutt@progressinheadfoot@linewidth}{1.30pt}
      \addtobeamertemplate{headline}{}{%
        \usebeamertemplate*{progress bar in head/foot}%
      }%
    },
    foot/.code={\pgfkeys{/ustutt/outer/progressbar=none}%
      \setbeamertemplate{headline}[ustutt]%
      \setbeamertemplate{frametitle}[ustutt]%
      \setbeamertemplate{footline}[ustutt]%
      \setlength{\ustutt@progressinheadfoot@linewidth}{1.30pt}
      \addtobeamertemplate{footline}{%
        \usebeamertemplate*{progress bar in head/foot}%
      }{}%
    },
}

% Patch calculation of footer height since our footers aren't just a single line height's high
% \patchcmd{\beamer@calculateheadfoot}{%
%   \advance\footheight by 5.00em%
% }{%
%   \advance\footheight by 2.00em%
% }{%
%   \@tempswatrue
% }{%
% }%
% \if@tempswa\else
%   \PackageError{beamerouterthemeustutt}{Patching calculateheadfoot failed}\@ehc
% \fi
% \@tempswafalse

\newcommand{\ustutt@outer@setdefaults}{%
  \pgfkeys{/ustutt/outer/.cd,%
    numbering=counter,%
    progressbar=none,%
  }%
}
\setbeamersize{
  text margin left=0.05\paperwidth,% sets a new left margin. This excludes the left sidebar. Thus, it is the distance between the right edge of the left sidebar and the left edge of the text.
  text margin right=0.05\paperwidth,% sets a new right margin
  sidebar width left=0.00pt,% sets the size of the left sidebar. Currently, this command should be given before a shading is installed for the sidebar canvas.
  sidebar width right=0.00pt,% sets the size of the right sidebar.
  % description width=0.00pt,% sets the default width of description labels, see Section 12.1 of the beameruserguide.pdf
  % description width of={},%  sets the default width of description labels to the width of the ⟨text⟩, see Section 12.1 of the beameruserguide.pdf
  % mini frame size=0,% sets the size of mini frames in a navigation bar. When two mini frame icons are shown alongside each other, their left end points are ⟨TEX dimension⟩ far apart.
  % mini frame offset=0,% set an additional vertical offset that is added to the mini frame size when arranging mini frames vertically.
}
\setbeamertemplate{navigation symbols}{}
\defbeamertemplate{frame footer}{none}{}
\defbeamertemplate{frame footer}{custom}[1]{ #1 }
\defbeamertemplate{frame numbering}{none}{}
\defbeamertemplate{frame numbering}{counter}{%
  \usebeamerfont{frame number in foot}%
  \usebeamercolor[fg]{frame number in foot}%
  \insertframenumber%
}
\defbeamertemplate*{frame numbering}{fraction}{%
  \usebeamerfont{frame number in foot}%
  \usebeamercolor[fg]{frame number in foot}%
  \insertframenumber/\inserttotalframenumber%
}

% Plain headline
\defbeamertemplate{headline}{plain}{}

% UStudd headline
\defbeamertemplate*{headline}{ustutt}{}%

% Plain footline
\defbeamertemplate{footline}{plain}{%
  \begin{beamercolorbox}[%
      wd=0.90\pagewidth,%
      sep=0.00pt,%
      leftskip=\ustutt@footline@padding,%
      rightskip=\ustutt@footline@padding,%
    ]{footline}%
    %
    \usebeamerfont{page number in head/foot}%
    \usebeamertemplate*{frame footer}
    \hfill%
    \usebeamertemplate*{frame numbering}
  \end{beamercolorbox}%
}

% UStutt footline
\defbeamertemplate*{footline}{ustutt simple}{%
  \leavevmode%
  {%
    \begin{beamercolorbox}[%
        wd=0.333333\paperwidth,%
        ht=1.00em,%
        dp=0.33em,%
        center%
      ]{author in head/foot}%
        \usebeamerfont{author in head/foot}\insertshortauthor\expandafter\ifblank\expandafter{\beamer@shortinstitute}{}{~~(\insertshortinstitute)}
    \end{beamercolorbox}%
    \begin{beamercolorbox}[%
        wd=0.333333\paperwidth,%
        ht=1.00em,%
        dp=0.33em,%
        center%
      ]{title in head/foot}%
        \usebeamerfont{title in head/foot}\insertshorttitle
    \end{beamercolorbox}%
    \begin{beamercolorbox}[%
        wd=0.333333\paperwidth,%
        ht=1.00em,%
        dp=0.33em,%
        right%
      ]{date in head/foot}%
        \usebeamerfont{date in head/foot}\insertshortdate{}%
        \hfill%
        \usebeamertemplate{frame numbering}\hspace*{2.00ex} 
    \end{beamercolorbox}%
  }%
  \vskip0.00pt%
}

\newlength{\ustutt@frametitle@padding}
\setlength{\ustutt@frametitle@padding}{0.0666\paperheight}
\newlength{\ustutt@footline@padding}
\setlength{\ustutt@footline@padding}{0.0666\paperheight}
\newcommand{\ustutt@frametitlestrut@start}{
  \rule{0.00pt}{\ustutt@frametitle@padding +%
    \totalheightof{%
      \ifcsdef{ustutt@frametitleformat}{\ustutt@frametitleformat X}{X}%
    }%
  }%
}
\newcommand{\ustutt@frametitlestrut@end}{
  \rule[-\ustutt@frametitle@padding]{0.00pt}{\ustutt@frametitle@padding}
}
\defbeamertemplate{frametitle}{plain}{%
  \nointerlineskip%
  \fbox{%
  \begin{beamercolorbox}[%
      wd=\paperwidth,%
      sep=0.00pt,%
      leftskip=0.05\paperwidth,%\ustutt@frametitle@padding,%
      rightskip=0.05\paperwidth,%\ustutt@frametitle@padding,%
    ]{frametitle}%
  \ustutt@frametitlestrut@start%
  \usebeamerfont{frametitle}%
  \insertframetitle\par%
  % \nolinebreak%
  \usebeamerfont{framesubtitle}%
  \insertframesubtitle
  \ustutt@frametitlestrut@end%
  \end{beamercolorbox}%
  }%
}
\setbeamertemplate{frametitle continuation}{%
  \usebeamerfont{frametitle}
  \romannumeral \insertcontinuationcount
}

% UStutt frame title template
\defbeamertemplate*{frametitle}{ustutt}{%
  \nointerlineskip%
  \begin{beamercolorbox}[%
      wd=\paperwidth,%
      dp=0.00ex,%
      ht=2.00\baselineskip,%
      sep=0.00pt,%
      leftskip=0.05\paperwidth,%\ustutt@frametitle@padding,%
      rightskip=0.05\paperwidth,%\ustutt@frametitle@padding,%
    ]{frametitle}%
  \ustutt@frametitlestrut@start%
  \usebeamerfont{frametitle}%
  \insertframetitle\par%
  % \nolinebreak%
  \usebeamerfont{framesubtitle}%
  \insertframesubtitle
  \ustutt@frametitlestrut@end%
  \end{beamercolorbox}%
}

\newlength{\ustutt@progressinheadfoot}
\newlength{\ustutt@progressinheadfoot@linewidth}
\setlength{\ustutt@progressinheadfoot@linewidth}{1.30pt}
\setbeamertemplate{progress bar in head/foot}{%
  \nointerlineskip%
  \setlength{\ustutt@progressinheadfoot}{%
    \paperwidth * \ratio{\insertframenumber pt}{\inserttotalframenumber pt}%
  }%
  \begin{beamercolorbox}[wd=\paperwidth]{progress bar in head/foot}
    \tikzexternaldisable%
    \begin{tikzpicture}%
      \fill[bg] (0.00,0.00) rectangle (\paperwidth, \ustutt@progressinheadfoot@linewidth);%
      \fill[fg] (0.00,0.00) rectangle (\ustutt@progressinheadfoot, \ustutt@progressinheadfoot@linewidth);%
    \end{tikzpicture}%
    \tikzexternalenable%
  \end{beamercolorbox}%
}%

\AtBeginDocument{%
  \apptocmd{\appendix}{%
    \pgfkeys{%
      /ustutt/outer/.cd,%
      numbering=none,%
      progressbar=none,%
    }%
  }{}{}%
}

\ustutt@outer@setdefaults

\ProcessPgfPackageOptions{/ustutt/outer}

\endinput
